/* gvSIG. Geographic Information System of the Valencian Government
 *
 * Copyright (C) 2007-2008 Infrastructures and Transports Department
 * of the Valencian Government (CIT)
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
 * MA  02110-1301, USA.
 * 
 */

/*
 * AUTHORS (In addition to CIT):
 * 2008 Software Colaborativo (www.scolab.es)   development
 */

package org.gvsig.workshop;

import java.awt.geom.Rectangle2D;
import java.util.List;

import javax.swing.JOptionPane;

import org.geonames.Toponym;
import org.geonames.ToponymSearchCriteria;
import org.geonames.ToponymSearchResult;
import org.geonames.WebService;

import com.iver.andami.PluginServices;
import com.iver.andami.plugins.Extension;
import com.iver.andami.ui.mdiManager.IWindow;
import com.iver.cit.gvsig.project.documents.view.gui.View;

public class GeoNamesExtension extends Extension {

	public void execute(String actionCommand) {
		IWindow w = PluginServices.getMDIManager().getActiveWindow();
		if (actionCommand.compareToIgnoreCase("TOPONIM") == 0) {
			String strToSearch = JOptionPane
					.showInputDialog("Introduzca el nombre a buscar:");
			if (strToSearch == null)
				return;
			ToponymSearchCriteria searchCriteria = new ToponymSearchCriteria();
			searchCriteria.setQ(strToSearch);
			ToponymSearchResult searchResult;
			try {
				searchResult = WebService.search(searchCriteria);
				double lon = 0, lat = 0;
				List list = searchResult.getToponyms();
				for (int i = 0; i < list.size(); i++) {
					Toponym toponym = (Toponym) list.get(i);
					System.out.println(toponym.getName() + " "
							+ toponym.getCountryName());
					System.out.println("Long: " + toponym.getLongitude()
							+ " Lat: " + toponym.getLatitude());
					lon = toponym.getLongitude();
					lat = toponym.getLatitude();
				}
				View v = (View) w;
				com.iver.cit.gvsig.fmap.ViewPort viewPort = v.getMapControl()
						.getMapContext().getViewPort();
				Rectangle2D r = viewPort.getAdjustedExtent();

				Rectangle2D nr = new Rectangle2D.Double(lon - r.getWidth()
						/ 2.0, lat - r.getHeight() / 2.0, r.getWidth(), r
						.getHeight());
				viewPort.setExtent(nr);
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

	}

	public void initialize() {
		// TODO Auto-generated method stub

	}

	public boolean isEnabled() {
		return true;
	}

	public boolean isVisible() {
		return true;
	}

}
