package org.gvsig.workshop;

import org.gvsig.workshop.gui.AddLayerToOverviewTocMenuEntry;
import org.gvsig.workshop.tools.MyInfoListener;

import com.iver.andami.PluginServices;
import com.iver.andami.plugins.Extension;
import com.iver.andami.ui.mdiManager.IWindow;
import com.iver.cit.gvsig.fmap.MapControl;
import com.iver.cit.gvsig.fmap.layers.FLayer;
import com.iver.cit.gvsig.fmap.tools.Behavior.PointBehavior;
import com.iver.cit.gvsig.project.documents.view.gui.IView;
import com.iver.utiles.extensionPoints.ExtensionPoints;
import com.iver.utiles.extensionPoints.ExtensionPointsSingleton;

public class MyInfoExtension extends Extension {

	MyInfoListener li = null;
	public void execute(String actionCommand) {
		IView view = (IView) PluginServices.getMDIManager().getActiveWindow();
		MapControl mapCtrl = view.getMapControl();
        if (li == null) // We create it for the first time.
        {
            li = new MyInfoListener(mapCtrl);
            mapCtrl.addMapTool("myInfo", new PointBehavior(li));
        }
        System.out.println("actionCommand=" + actionCommand);
        if (actionCommand.compareTo("INFO_PROVIN") == 0)
        {
            mapCtrl.setTool("myInfo");
        }

	}

	public void initialize() {
    	ExtensionPoints extensionPoints = ExtensionPointsSingleton.getInstance();
    	extensionPoints.add("View_TocActions","AddLayerToOverview",new AddLayerToOverviewTocMenuEntry());

		
	}

	public boolean isEnabled() {
		IWindow w = PluginServices.getMDIManager().getActiveWindow();
		if (w instanceof IView)
		{
			MapControl mapCtrl = ((IView) w).getMapControl();
			FLayer lyrProvin = mapCtrl.getMapContext().getLayers().getLayer("Provin.shp");
			if (lyrProvin != null)
				return true;
		}
		return false;
	}

	public boolean isVisible() {
		IWindow w = PluginServices.getMDIManager().getActiveWindow();
		if (w instanceof IView)
			return true;
		
		return false;
	}

}
