/* gvSIG. Geographic Information System of the Valencian Government
*
* Copyright (C) 2007-2008 Infrastructures and Transports Department
* of the Valencian Government (CIT)
* 
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
* MA  02110-1301, USA.
* 
*/

/*
* AUTHORS (In addition to CIT):
* 2008 Software Colaborativo (www.scolab.es)   development
*/
 
package org.gvsig.workshop.gui;

import com.iver.andami.PluginServices;
import com.iver.andami.ui.mdiManager.IWindow;
import com.iver.cit.gvsig.fmap.MapContext;
import com.iver.cit.gvsig.fmap.layers.FLayer;
import com.iver.cit.gvsig.project.documents.view.MapOverview;
import com.iver.cit.gvsig.project.documents.view.gui.View;
import com.iver.cit.gvsig.project.documents.view.toc.AbstractTocContextMenuAction;
import com.iver.cit.gvsig.project.documents.view.toc.ITocItem;

public class AddLayerToOverviewTocMenuEntry extends
		AbstractTocContextMenuAction {

	public void execute(ITocItem item, FLayer[] selectedItems) {
		IWindow w = PluginServices.getMDIManager().getActiveWindow();
		if (w instanceof View) {
			View v = (View) w;
			MapOverview overview = v.getMapOverview();
			MapContext context = overview.getMapContext();
			context.beginAtomicEvent();
			for (int i=0; i < selectedItems.length; i++) {				
				context.getLayers().addLayer(selectedItems[i]);
			}
			context.endAtomicEvent();
		}

	}

	public String getText() {
		return PluginServices.getText(this, "CopyLayerToMapOverview");
	}

}

