package org.gvsig.workshop.tools;

import com.iver.andami.messages.NotificationManager;
import com.iver.cit.gvsig.fmap.DriverException;
import com.iver.cit.gvsig.fmap.core.IGeometry;
import com.iver.cit.gvsig.fmap.core.v02.FConverter;
import com.iver.cit.gvsig.fmap.drivers.DriverIOException;
import com.iver.cit.gvsig.fmap.layers.FBitSet;
import com.iver.cit.gvsig.fmap.layers.FLyrVect;
import com.iver.cit.gvsig.fmap.operations.strategies.DefaultStrategy;
import com.iver.cit.gvsig.fmap.operations.strategies.VisitException;
import com.iver.cit.gvsig.gui.cad.tools.PolylineCADTool;
import com.vividsolutions.jts.geom.Geometry;

public class AutoCompletePolygon extends PolylineCADTool {

	private IGeometry autoComplete(IGeometry geom) {
		IGeometry digitizedGeom = geom;
		Geometry jtsGeom = digitizedGeom.toJTSGeometry();
		FLyrVect lyrVect = (FLyrVect) getVLE().getLayer();
		// Se supone que debe ser rpido, ya que est indexado
		FBitSet selected;
		try {
			selected = lyrVect.queryByShape(digitizedGeom,
					DefaultStrategy.INTERSECTS);
			for (int i = selected.nextSetBit(0); i >= 0; i = selected
					.nextSetBit(i + 1)) {
				IGeometry aux = lyrVect.getSource().getShape(i);
				Geometry jtsAux = aux.toJTSGeometry();
				jtsGeom = jtsGeom.difference(jtsAux);
			}
		return FConverter.jts_to_igeometry(jtsGeom);
		} catch (DriverException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (VisitException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (DriverIOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}

	public void addGeometry(IGeometry geometry) {
		IGeometry newGeom = autoComplete(geometry);
		super.addGeometry(newGeom);
	}
}
