package org.gvsig.workshop.tools;

import java.awt.Component;
import java.awt.Cursor;
import java.awt.geom.Point2D;

import javax.swing.JOptionPane;

import org.gvsig.workshop.gui.DlgProvin;

import com.iver.andami.PluginServices;
import com.iver.andami.messages.NotificationManager;
import com.iver.cit.gvsig.fmap.MapControl;
import com.iver.cit.gvsig.fmap.ViewPort;
import com.iver.cit.gvsig.fmap.layers.FBitSet;
import com.iver.cit.gvsig.fmap.layers.FLayers;
import com.iver.cit.gvsig.fmap.layers.FLyrVect;
import com.iver.cit.gvsig.fmap.layers.SelectableDataSource;
import com.iver.cit.gvsig.fmap.tools.BehaviorException;
import com.iver.cit.gvsig.fmap.tools.Events.PointEvent;
import com.iver.cit.gvsig.project.documents.view.toolListeners.InfoListener;

public class MyInfoListener extends InfoListener {
	private Cursor cur = java.awt.Cursor.getPredefinedCursor(Cursor.HAND_CURSOR);
	private MapControl mc;
	private DlgProvin dlg = null;

	public MyInfoListener(MapControl mc) {
		super(mc);
		this.mc = mc;
	}

	public Cursor getCursor() {
		return cur;
	}

	public void point(PointEvent event) throws BehaviorException {
		ViewPort vp = mc.getViewPort();
		Point2D pReal = vp.toMapPoint(event.getPoint());

        FLayers lyrs = mc.getMapContext().getLayers();
        FLyrVect lyrProvin = (FLyrVect) lyrs.getLayer("Provin.shp");
        try {
        	SelectableDataSource ds =lyrProvin.getRecordset(); 
        	int idField = ds.getFieldIndexByName("NOMBRE");
        	if (idField == -1) {
        		JOptionPane.showMessageDialog((Component) PluginServices.getMDIManager().getActiveWindow(),
        				"No encuentro el campo NOMBRE");
        		return;
        	}
        	
			FBitSet bs = lyrProvin.queryByPoint(pReal, 10.0);
			if (dlg == null)
			{
				dlg = new DlgProvin();				
			}
			dlg = (DlgProvin) PluginServices.getMDIManager().addWindow(dlg);
			for (int i=bs.nextSetBit(0); i >=0; i=bs.nextSetBit(i+1))
			{
				long idRec = i;
				String nom = ds.getFieldValue(idRec, idField).toString();
				dlg.setProvinName(nom);
			}

		} catch (Exception e) {
			e.printStackTrace();
			NotificationManager.addError(e);
		}

		
		
	}

}
